// This file is generated by kconfig_compiler from kbprojectsettings.kcfg.
// All changes you do to this file will be lost.
#ifndef KBABEL_PROJECTSETTINGSBASE_H
#define KBABEL_PROJECTSETTINGSBASE_H

#include <kglobal.h>
#include <kconfigskeleton.h>
#include <kdebug.h>

#include <catalogsettings.h>
#include <projectsettings.h>
namespace KBabel {

class ProjectSettingsBase : public KConfigSkeleton
{
  public:
    enum { Custom, Default, Local };
    enum { Locale, UTF8, UTF16 };
    enum { Remove, Update, NoChange, RemoveLine };
    enum { File, Database, Msgstr };

    ProjectSettingsBase( KSharedConfig::Ptr config = KGlobal::sharedConfig() );
    ~ProjectSettingsBase();

    /**
      Set List of command names for directories
    */
    void setDirCommandNames( const QStringList & v )
    {
      if (!isImmutable( QString::fromLatin1( "DirCommandNames" ) ))
        mDirCommandNames = v;
    }

    /**
      Get List of command names for directories
    */
    QStringList dirCommandNames() const
    {
      return mDirCommandNames;
    }

    /**
      Set List of commands for directories
    */
    void setDirCommands( const QStringList & v )
    {
      if (!isImmutable( QString::fromLatin1( "DirCommands" ) ))
        mDirCommands = v;
    }

    /**
      Get List of commands for directories
    */
    QStringList dirCommands() const
    {
      return mDirCommands;
    }

    /**
      Set List of command names for files
    */
    void setFileCommandNames( const QStringList & v )
    {
      if (!isImmutable( QString::fromLatin1( "FileCommandNames" ) ))
        mFileCommandNames = v;
    }

    /**
      Get List of command names for files
    */
    QStringList fileCommandNames() const
    {
      return mFileCommandNames;
    }

    /**
      Set List of commands for files
    */
    void setFileCommands( const QStringList & v )
    {
      if (!isImmutable( QString::fromLatin1( "FileCommands" ) ))
        mFileCommands = v;
    }

    /**
      Get List of commands for files
    */
    QStringList fileCommands() const
    {
      return mFileCommands;
    }

    /**
      Set If the file cache should contain also index of words for faster searching
    */
    void setIndexWords( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "IndexWords" ) ))
        mIndexWords = v;
    }

    /**
      Get If the file cache should contain also index of words for faster searching
    */
    bool indexWords() const
    {
      return mIndexWords;
    }

    /**
      Set If the Catalog Manager should kill all running its gettext tools at exit
    */
    void setKillCmdOnExit( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "KillCmdOnExit" ) ))
        mKillCmdOnExit = v;
    }

    /**
      Get If the Catalog Manager should kill all running its gettext tools at exit
    */
    bool killCmdOnExit() const
    {
      return mKillCmdOnExit;
    }

    /**
      Set msgfmt
    */
    void setMsgfmt( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "msgfmt" ) ))
        mMsgfmt = v;
    }

    /**
      Get msgfmt
    */
    bool msgfmt() const
    {
      return mMsgfmt;
    }

    /**
      Set List of files marked
    */
    void setMarker( const QStringList & v )
    {
      if (!isImmutable( QString::fromLatin1( "Marker" ) ))
        mMarker = v;
    }

    /**
      Get List of files marked
    */
    QStringList marker() const
    {
      return mMarker;
    }

    /**
      Set If the files should be open in new KBabel editor windows
    */
    void setOpenWindow( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "OpenWindow" ) ))
        mOpenWindow = v;
    }

    /**
      Get If the files should be open in new KBabel editor windows
    */
    bool openWindow() const
    {
      return mOpenWindow;
    }

    /**
      Set The base directory for PO files (translations)
    */
    void setPoBaseDir( const QString & v )
    {
      if (!isImmutable( QString::fromLatin1( "PoBaseDir" ) ))
        mPoBaseDir = v;
    }

    /**
      Get The base directory for PO files (translations)
    */
    QString poBaseDir() const
    {
      return mPoBaseDir;
    }

    /**
      Set The base directory for POT files (templates to be translated)
    */
    void setPotBaseDir( const QString & v )
    {
      if (!isImmutable( QString::fromLatin1( "PotBaseDir" ) ))
        mPotBaseDir = v;
    }

    /**
      Get The base directory for POT files (templates to be translated)
    */
    QString potBaseDir() const
    {
      return mPotBaseDir;
    }

    /**
      Set ShowTotalColumn
    */
    void setShowTotalColumn( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "ShowTotalColumn" ) ))
        mShowTotalColumn = v;
    }

    /**
      Get ShowTotalColumn
    */
    bool showTotalColumn() const
    {
      return mShowTotalColumn;
    }

    /**
      Set ShowCVSColumn
    */
    void setShowCVSColumn( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "ShowCVSColumn" ) ))
        mShowCVSColumn = v;
    }

    /**
      Get ShowCVSColumn
    */
    bool showCVSColumn() const
    {
      return mShowCVSColumn;
    }

    /**
      Set ShowFlagColumn
    */
    void setShowFlagColumn( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "ShowFlagColumn" ) ))
        mShowFlagColumn = v;
    }

    /**
      Get ShowFlagColumn
    */
    bool showFlagColumn() const
    {
      return mShowFlagColumn;
    }

    /**
      Set ShowFuzzyColumn
    */
    void setShowFuzzyColumn( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "ShowFuzzyColumn" ) ))
        mShowFuzzyColumn = v;
    }

    /**
      Get ShowFuzzyColumn
    */
    bool showFuzzyColumn() const
    {
      return mShowFuzzyColumn;
    }

    /**
      Set ShowRevisionColumn
    */
    void setShowRevisionColumn( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "ShowRevisionColumn" ) ))
        mShowRevisionColumn = v;
    }

    /**
      Get ShowRevisionColumn
    */
    bool showRevisionColumn() const
    {
      return mShowRevisionColumn;
    }

    /**
      Set ShowTranslatorColumn
    */
    void setShowTranslatorColumn( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "ShowTranslatorColumn" ) ))
        mShowTranslatorColumn = v;
    }

    /**
      Get ShowTranslatorColumn
    */
    bool showTranslatorColumn() const
    {
      return mShowTranslatorColumn;
    }

    /**
      Set ShowUntranslatedColumn
    */
    void setShowUntranslatedColumn( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "ShowUntranslatedColumn" ) ))
        mShowUntranslatedColumn = v;
    }

    /**
      Get ShowUntranslatedColumn
    */
    bool showUntranslatedColumn() const
    {
      return mShowUntranslatedColumn;
    }

    /**
      Set ValidationIgnoreURL
    */
    void setValidationIgnoreURL( const QString & v )
    {
      if (!isImmutable( QString::fromLatin1( "ValidationIgnoreURL" ) ))
        mValidationIgnoreURL = v;
    }

    /**
      Get ValidationIgnoreURL
    */
    QString validationIgnoreURL() const
    {
      return mValidationIgnoreURL;
    }

    /**
      Set Email of the translator
    */
    void setAuthorEmail( const QString & v )
    {
      if (!isImmutable( QString::fromLatin1( "AuthorEmail" ) ))
        mAuthorEmail = v;
    }

    /**
      Get Email of the translator
    */
    QString authorEmail() const
    {
      return mAuthorEmail;
    }

    /**
      Set Name of the translator (non-localized)
    */
    void setAuthorName( const QString & v )
    {
      if (!isImmutable( QString::fromLatin1( "AuthorName" ) ))
        mAuthorName = v;
    }

    /**
      Get Name of the translator (non-localized)
    */
    QString authorName() const
    {
      return mAuthorName;
    }

    /**
      Set Delay in minutes between autosaves. 0 disables autosave.
    */
    void setAutoSaveDelay( uint v )
    {
      if (!isImmutable( QString::fromLatin1( "AutoSaveDelay" ) ))
        mAutoSaveDelay = v;
    }

    /**
      Get Delay in minutes between autosaves. 0 disables autosave.
    */
    uint autoSaveDelay() const
    {
      return mAutoSaveDelay;
    }

    /**
      Set If the syntax should be checked before save
    */
    void setAutoSyntaxCheck( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "AutoSyntaxCheck" ) ))
        mAutoSyntaxCheck = v;
    }

    /**
      Get If the syntax should be checked before save
    */
    bool autoSyntaxCheck() const
    {
      return mAutoSyntaxCheck;
    }

    /**
      Set If the header should be automatically updated on save
    */
    void setAutoUpdate( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "AutoUpdate" ) ))
        mAutoUpdate = v;
    }

    /**
      Get If the header should be automatically updated on save
    */
    bool autoUpdate() const
    {
      return mAutoUpdate;
    }

    /**
      Set If the plural argument is required to be a part of translation
    */
    void setCheckPluralArgument( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "CheckPluralArgument" ) ))
        mCheckPluralArgument = v;
    }

    /**
      Get If the plural argument is required to be a part of translation
    */
    bool checkPluralArgument() const
    {
      return mCheckPluralArgument;
    }

    /**
      Set Custom date format used if DateFormat specifies that
    */
    void setCustomDateFormat( const QString & v )
    {
      if (!isImmutable( QString::fromLatin1( "CustomDateFormat" ) ))
        mCustomDateFormat = v;
    }

    /**
      Get Custom date format used if DateFormat specifies that
    */
    QString customDateFormat() const
    {
      return mCustomDateFormat;
    }

    /**
      Set Format of the dates stored
    */
    void setDateFormat( int v )
    {
      if (!isImmutable( QString::fromLatin1( "DateFormat" ) ))
        mDateFormat = v;
    }

    /**
      Get Format of the dates stored
    */
    int dateFormat() const
    {
      return mDateFormat;
    }

    /**
      Set Description of the translation
    */
    void setDescriptionString( const QString & v )
    {
      if (!isImmutable( QString::fromLatin1( "DescriptionString" ) ))
        mDescriptionString = v;
    }

    /**
      Get Description of the translation
    */
    QString descriptionString() const
    {
      return mDescriptionString;
    }

    /**
      Set The encoding of the file
    */
    void setEncoding( int v )
    {
      if (!isImmutable( QString::fromLatin1( "Encoding" ) ))
        mEncoding = v;
    }

    /**
      Get The encoding of the file
    */
    int encoding() const
    {
      return mEncoding;
    }

    /**
      Set The way how to handle Free Software Foundation header
    */
    void setFSFCopyright( int v )
    {
      if (!isImmutable( QString::fromLatin1( "FSFCopyright" ) ))
        mFSFCopyright = v;
    }

    /**
      Get The way how to handle Free Software Foundation header
    */
    int fSFCopyright() const
    {
      return mFSFCopyright;
    }

    /**
      Set English name of the language
    */
    void setLanguage( const QString & v )
    {
      if (!isImmutable( QString::fromLatin1( "Language" ) ))
        mLanguage = v;
    }

    /**
      Get English name of the language
    */
    QString language() const
    {
      return mLanguage;
    }

    /**
      Set ISO 631 language code
    */
    void setLanguageCode( const QString & v )
    {
      if (!isImmutable( QString::fromLatin1( "LanguageCode" ) ))
        mLanguageCode = v;
    }

    /**
      Get ISO 631 language code
    */
    QString languageCode() const
    {
      return mLanguageCode;
    }

    /**
      Set Localized name of the author
    */
    void setLocalAuthorName( const QString & v )
    {
      if (!isImmutable( QString::fromLatin1( "LocalAuthorName" ) ))
        mLocalAuthorName = v;
    }

    /**
      Get Localized name of the author
    */
    QString localAuthorName() const
    {
      return mLocalAuthorName;
    }

    /**
      Set Mailing list for i18n of the langauge
    */
    void setMailinglist( const QString & v )
    {
      if (!isImmutable( QString::fromLatin1( "Mailinglist" ) ))
        mMailinglist = v;
    }

    /**
      Get Mailing list for i18n of the langauge
    */
    QString mailinglist() const
    {
      return mMailinglist;
    }

    /**
      Set Number of plural forms for the language
    */
    void setPluralForms( uint v )
    {
      if (!isImmutable( QString::fromLatin1( "PluralForms" ) ))
        mPluralForms = v;
    }

    /**
      Get Number of plural forms for the language
    */
    uint pluralForms() const
    {
      return mPluralForms;
    }

    /**
      Set Plural forms specification for GNU gettext
    */
    void setPluralFormsHeader( const QString & v )
    {
      if (!isImmutable( QString::fromLatin1( "PluralFormsHeader" ) ))
        mPluralFormsHeader = v;
    }

    /**
      Get Plural forms specification for GNU gettext
    */
    QString pluralFormsHeader() const
    {
      return mPluralFormsHeader;
    }

    /**
      Set Macro-based string to fill Project GNU header
    */
    void setProjectString( const QString & v )
    {
      if (!isImmutable( QString::fromLatin1( "ProjectString" ) ))
        mProjectString = v;
    }

    /**
      Get Macro-based string to fill Project GNU header
    */
    QString projectString() const
    {
      return mProjectString;
    }

    /**
      Set If the obsolete translation entries should be saved
    */
    void setSaveObsolete( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "SaveObsolete" ) ))
        mSaveObsolete = v;
    }

    /**
      Get If the obsolete translation entries should be saved
    */
    bool saveObsolete() const
    {
      return mSaveObsolete;
    }

    /**
      Set Timezone of the translation (needed for updating time stamps)
    */
    void setTimezone( const QString & v )
    {
      if (!isImmutable( QString::fromLatin1( "Timezone" ) ))
        mTimezone = v;
    }

    /**
      Get Timezone of the translation (needed for updating time stamps)
    */
    QString timezone() const
    {
      return mTimezone;
    }

    /**
      Set UpdateCharset
    */
    void setUpdateCharset( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "UpdateCharset" ) ))
        mUpdateCharset = v;
    }

    /**
      Get UpdateCharset
    */
    bool updateCharset() const
    {
      return mUpdateCharset;
    }

    /**
      Set UpdateEncoding
    */
    void setUpdateEncoding( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "UpdateEncoding" ) ))
        mUpdateEncoding = v;
    }

    /**
      Get UpdateEncoding
    */
    bool updateEncoding() const
    {
      return mUpdateEncoding;
    }

    /**
      Set UpdateLanguageTeam
    */
    void setUpdateLanguageTeam( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "UpdateLanguageTeam" ) ))
        mUpdateLanguageTeam = v;
    }

    /**
      Get UpdateLanguageTeam
    */
    bool updateLanguageTeam() const
    {
      return mUpdateLanguageTeam;
    }

    /**
      Set UpdateLastTranslator
    */
    void setUpdateLastTranslator( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "UpdateLastTranslator" ) ))
        mUpdateLastTranslator = v;
    }

    /**
      Get UpdateLastTranslator
    */
    bool updateLastTranslator() const
    {
      return mUpdateLastTranslator;
    }

    /**
      Set UpdateProject
    */
    void setUpdateProject( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "UpdateProject" ) ))
        mUpdateProject = v;
    }

    /**
      Get UpdateProject
    */
    bool updateProject() const
    {
      return mUpdateProject;
    }

    /**
      Set UpdateRevisionDate
    */
    void setUpdateRevisionDate( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "UpdateRevisionDate" ) ))
        mUpdateRevisionDate = v;
    }

    /**
      Get UpdateRevisionDate
    */
    bool updateRevisionDate() const
    {
      return mUpdateRevisionDate;
    }

    /**
      Set UpdateDescription
    */
    void setUpdateDescription( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "UpdateDescription" ) ))
        mUpdateDescription = v;
    }

    /**
      Get UpdateDescription
    */
    bool updateDescription() const
    {
      return mUpdateDescription;
    }

    /**
      Set UpdateTranslatorCopyright
    */
    void setUpdateTranslatorCopyright( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "UpdateTranslatorCopyright" ) ))
        mUpdateTranslatorCopyright = v;
    }

    /**
      Get UpdateTranslatorCopyright
    */
    bool updateTranslatorCopyright() const
    {
      return mUpdateTranslatorCopyright;
    }

    /**
      Set If the saving should preserve the encoding of the file, if already defined
        
    */
    void setUseOldEncoding( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "UseOldEncoding" ) ))
        mUseOldEncoding = v;
    }

    /**
      Get If the saving should preserve the encoding of the file, if already defined
        
    */
    bool useOldEncoding() const
    {
      return mUseOldEncoding;
    }

    /**
      Set Marker for accelerators
    */
    void setAccelMarker( const QString & v )
    {
      if (!isImmutable( QString::fromLatin1( "AccelMarker" ) ))
        mAccelMarker = v;
    }

    /**
      Get Marker for accelerators
    */
    QString accelMarker() const
    {
      return mAccelMarker;
    }

    /**
      Set If the files should be compressed for mailing
    */
    void setBZipCompression( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "BZipCompression" ) ))
        mBZipCompression = v;
    }

    /**
      Get If the files should be compressed for mailing
    */
    bool bZipCompression() const
    {
      return mBZipCompression;
    }

    /**
      Set If even single file should be compressed for mailing
    */
    void setCompressSingleFile( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "CompressSingleFile" ) ))
        mCompressSingleFile = v;
    }

    /**
      Get If even single file should be compressed for mailing
    */
    bool compressSingleFile() const
    {
      return mCompressSingleFile;
    }

    /**
      Set Regular expression for identifying a context information in original text
    */
    void setContextInfo( const QString & v )
    {
      if (!isImmutable( QString::fromLatin1( "ContextInfo" ) ))
        mContextInfo = v;
    }

    /**
      Get Regular expression for identifying a context information in original text
    */
    QString contextInfo() const
    {
      return mContextInfo;
    }

    /**
      Set List of recent mailed archives
    */
    void setMailArchiveNames( const QStringList & v )
    {
      if (!isImmutable( QString::fromLatin1( "MailArchiveNames" ) ))
        mMailArchiveNames = v;
    }

    /**
      Get List of recent mailed archives
    */
    QStringList mailArchiveNames() const
    {
      return mMailArchiveNames;
    }

    /**
      Set Regular expression for identifying a KDE plural form
    */
    void setSingularPlural( const QString & v )
    {
      if (!isImmutable( QString::fromLatin1( "SingularPlural" ) ))
        mSingularPlural = v;
    }

    /**
      Get Regular expression for identifying a KDE plural form
    */
    QString singularPlural() const
    {
      return mSingularPlural;
    }

    /**
      Set DiffBaseDir
    */
    void setDiffBaseDir( const QString & v )
    {
      if (!isImmutable( QString::fromLatin1( "DiffBaseDir" ) ))
        mDiffBaseDir = v;
    }

    /**
      Get DiffBaseDir
    */
    QString diffBaseDir() const
    {
      return mDiffBaseDir;
    }

    /**
      Set UseDBForDiff
    */
    void setUseDBForDiff( int v )
    {
      if (!isImmutable( QString::fromLatin1( "UseDBForDiff" ) ))
        mUseDBForDiff = v;
    }

    /**
      Get UseDBForDiff
    */
    int useDBForDiff() const
    {
      return mUseDBForDiff;
    }

    /**
      Set Name of the project
    */
    void setName( const QString & v )
    {
      if (!isImmutable( QString::fromLatin1( "Name" ) ))
        mName = v;
    }

    /**
      Get Name of the project
    */
    QString name() const
    {
      return mName;
    }

    /**
      Set Version of the configuration file
    */
    void setVersion( const QString & v )
    {
      if (!isImmutable( QString::fromLatin1( "Version" ) ))
        mVersion = v;
    }

    /**
      Get Version of the configuration file
    */
    QString version() const
    {
      return mVersion;
    }

    /**
      Set IgnoreURL
    */
    void setIgnoreURL( const QString & v )
    {
      if (!isImmutable( QString::fromLatin1( "IgnoreURL" ) ))
        mIgnoreURL = v;
    }

    /**
      Get IgnoreURL
    */
    QString ignoreURL() const
    {
      return mIgnoreURL;
    }

    /**
      Set NoRootAffix
    */
    void setNoRootAffix( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "NoRootAffix" ) ))
        mNoRootAffix = v;
    }

    /**
      Get NoRootAffix
    */
    bool noRootAffix() const
    {
      return mNoRootAffix;
    }

    /**
      Set OnFlySpellCheck
    */
    void setOnFlySpellCheck( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "OnFlySpellCheck" ) ))
        mOnFlySpellCheck = v;
    }

    /**
      Get OnFlySpellCheck
    */
    bool onFlySpellCheck() const
    {
      return mOnFlySpellCheck;
    }

    /**
      Set RememberIgnored
    */
    void setRememberIgnored( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "RememberIgnored" ) ))
        mRememberIgnored = v;
    }

    /**
      Get RememberIgnored
    */
    bool rememberIgnored() const
    {
      return mRememberIgnored;
    }

    /**
      Set RunTogether
    */
    void setRunTogether( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "RunTogether" ) ))
        mRunTogether = v;
    }

    /**
      Get RunTogether
    */
    bool runTogether() const
    {
      return mRunTogether;
    }

    /**
      Set SpellClient
    */
    void setSpellClient( uint v )
    {
      if (!isImmutable( QString::fromLatin1( "SpellClient" ) ))
        mSpellClient = v;
    }

    /**
      Get SpellClient
    */
    uint spellClient() const
    {
      return mSpellClient;
    }

    /**
      Set SpellDictionary
    */
    void setSpellDictionary( const QString & v )
    {
      if (!isImmutable( QString::fromLatin1( "SpellDictionary" ) ))
        mSpellDictionary = v;
    }

    /**
      Get SpellDictionary
    */
    QString spellDictionary() const
    {
      return mSpellDictionary;
    }

    /**
      Set SpellEncoding
    */
    void setSpellEncoding( uint v )
    {
      if (!isImmutable( QString::fromLatin1( "SpellEncoding" ) ))
        mSpellEncoding = v;
    }

    /**
      Get SpellEncoding
    */
    uint spellEncoding() const
    {
      return mSpellEncoding;
    }

    /**
      Set TagExpressions
    */
    void setTagExpressions( const QString & v )
    {
      if (!isImmutable( QString::fromLatin1( "TagExpressions" ) ))
        mTagExpressions = v;
    }

    /**
      Get TagExpressions
    */
    QString tagExpressions() const
    {
      return mTagExpressions;
    }

    /**
      Set CodeRoot
    */
    void setCodeRoot( const QString & v )
    {
      if (!isImmutable( QString::fromLatin1( "CodeRoot" ) ))
        mCodeRoot = v;
    }

    /**
      Get CodeRoot
    */
    QString codeRoot() const
    {
      return mCodeRoot;
    }

    /**
      Set Paths
    */
    void setPaths( const QStringList & v )
    {
      if (!isImmutable( QString::fromLatin1( "Paths" ) ))
        mPaths = v;
    }

    /**
      Get Paths
    */
    QStringList paths() const
    {
      return mPaths;
    }

  protected:

    // CatalogManager
    QStringList mDirCommandNames;
    QStringList mDirCommands;
    QStringList mFileCommandNames;
    QStringList mFileCommands;
    bool mIndexWords;
    bool mKillCmdOnExit;
    bool mMsgfmt;
    QStringList mMarker;
    bool mOpenWindow;
    QString mPoBaseDir;
    QString mPotBaseDir;
    bool mShowTotalColumn;
    bool mShowCVSColumn;
    bool mShowFlagColumn;
    bool mShowFuzzyColumn;
    bool mShowRevisionColumn;
    bool mShowTranslatorColumn;
    bool mShowUntranslatedColumn;
    QString mValidationIgnoreURL;

    // Header
    QString mAuthorEmail;
    QString mAuthorName;
    uint mAutoSaveDelay;
    bool mAutoSyntaxCheck;
    bool mAutoUpdate;
    bool mCheckPluralArgument;
    QString mCustomDateFormat;
    int mDateFormat;
    QString mDescriptionString;
    int mEncoding;
    int mFSFCopyright;
    QString mLanguage;
    QString mLanguageCode;
    QString mLocalAuthorName;
    QString mMailinglist;
    uint mPluralForms;
    QString mPluralFormsHeader;
    QString mProjectString;
    bool mSaveObsolete;
    QString mTimezone;
    bool mUpdateCharset;
    bool mUpdateEncoding;
    bool mUpdateLanguageTeam;
    bool mUpdateLastTranslator;
    bool mUpdateProject;
    bool mUpdateRevisionDate;
    bool mUpdateDescription;
    bool mUpdateTranslatorCopyright;
    bool mUseOldEncoding;

    // Misc
    QString mAccelMarker;
    bool mBZipCompression;
    bool mCompressSingleFile;
    QString mContextInfo;
    QStringList mMailArchiveNames;
    QString mSingularPlural;
    QString mDiffBaseDir;
    int mUseDBForDiff;

    // Project
    QString mName;
    QString mVersion;

    // Spellcheck
    QString mIgnoreURL;
    bool mNoRootAffix;
    bool mOnFlySpellCheck;
    bool mRememberIgnored;
    bool mRunTogether;
    uint mSpellClient;
    QString mSpellDictionary;
    uint mSpellEncoding;

    // Tags
    QString mTagExpressions;

    // SourceContext
    QString mCodeRoot;
    QStringList mPaths;

  private:
};

}

#endif

