/**
 * <b>SOFTWARE RIGHTS</b>
 * <p>
 * ANTLR 2.6.0 MageLang Insitute, 1998
 * <p>
 * We reserve no legal rights to the ANTLR--it is fully in the
 * public domain. An individual or company may do whatever
 * they wish with source code distributed with ANTLR or the
 * code generated by ANTLR, including the incorporation of
 * ANTLR, or its output, into commerical software.
 * <p>
 * We encourage users to develop software with ANTLR. However,
 * we do ask that credit is given to us for developing
 * ANTLR. By "credit", we mean that if you use ANTLR or
 * incorporate any source code into one of your programs
 * (commercial product, research project, or otherwise) that
 * you acknowledge this fact somewhere in the documentation,
 * research report, etc... If you like ANTLR and have
 * developed a nice tool with the output, please mention that
 * you developed it using ANTLR. In addition, we ask that the
 * headers remain intact in our source code. As long as these
 * guidelines are kept, we expect to continue enhancing this
 * system and expect to make other tools available as they are
 * completed.
 * <p>
 * The ANTLR gang:
 * @version ANTLR 2.6.0 MageLang Insitute, 1998
 * @author Terence Parr, <a href=http://www.MageLang.com>MageLang Institute</a>
 * @author <br>John Lilley, <a href=http://www.Empathy.com>Empathy Software</a>
 * @author <br><a href="mailto:pete@yamuna.demon.co.uk">Pete Wells</a>
 */

#include "antlr/RecognitionException.hpp"
#include "antlr/String.hpp"

ANTLR_BEGIN_NAMESPACE(antlr)

RecognitionException::RecognitionException()
: ANTLRException("parsing error"), line(1), column(1)
{}

RecognitionException::RecognitionException(const ANTLR_USE_NAMESPACE(std)string& s)
: ANTLRException(s)
{}

RecognitionException::RecognitionException(const ANTLR_USE_NAMESPACE(std)string& s,const ANTLR_USE_NAMESPACE(std)string& fileName_,int line_)
: ANTLRException(s), fileName(fileName_), line(line_)
{}

RecognitionException::RecognitionException(const ANTLR_USE_NAMESPACE(std)string& s,const ANTLR_USE_NAMESPACE(std)string& fileName_,int line_,int column_)
: ANTLRException(s), fileName(fileName_), line(line_), column(column_)
{}

int RecognitionException::getColumn() const
{
	return column;
}

ANTLR_USE_NAMESPACE(std)string RecognitionException::getErrorMessage() const
{
	return getMessage();
}

ANTLR_USE_NAMESPACE(std)string RecognitionException::getFileLineString() const
{
	if ( fileName.length() ) 
		return fileName+": "+line+": ";
	else 
		return ANTLR_USE_NAMESPACE(std)string("line ")+line+": ";
}

ANTLR_USE_NAMESPACE(std)string RecognitionException::getFilename() const
{
	return fileName;
}

int RecognitionException::getLine() const
{
	return line;
}

ANTLR_USE_NAMESPACE(std)string RecognitionException::toString() const
{
	return getFileLineString()+getMessage();
}

ANTLR_END_NAMESPACE
